@auth.requires_login()
def new_D():
    #Recherche si user est déjà délégué
    enregistrement=(db.Delegues.U_id==auth.user.id)
    if len(db(enregistrement).select())>0:
        deleg=db(enregistrement).select(db.Delegues.ALL)[0]
        response.flash="Vous êtes déjà incrit comme délégué, voici vos paramètres ,vous pouvez les modifier..."
        form=FORM(TABLE(TR("Présentation  :",TEXTAREA(_name="zetext",value=deleg.Presentation)),
                        TR("Lien vers blog:",INPUT(_type="text",_style="width:378px",_name="lien",value=deleg.lien)),   
                           "",     INPUT(_type="submit",_value="Modifier")))
        if form.accepts(request.vars,session):
            db(enregistrement).update(Presentation=form.vars.zetext,
                                      lien=form.vars.lien)  
            session.flash="Vos modifications ont étés prises en compte..."
            redirect(URL(r=request,c='default',f='listes'))#,args=[tag_num]))

    else:
        response.flash="Vous allez vous inscrire comme délégué,merci de vous présenter..."
        db.Delegues.U_id.default=auth.user.id                #request.args[0]
        form=SQLFORM(db.Delegues)
        if form.accepts(request.vars,session):
            session.flash="Votre proposition de délégation est prise en compte..."
            redirect(URL(r=request,c='default',f='listes'))#,args=[tag_num]))

    return dict(form=form)
    
    
@auth.requires_login()
def accepte_question():
    message='vide'
    form='vide'
    #Utilisée pour l'acceptation de délégation 
    q=request.args[0]
    row=db(db.Questions.id==q).select(db.Questions.ALL)[0]
    question=row.description

    #Recherche si user est délégué
    enregistrement=(db.Delegues.U_id==auth.user.id)
    if len(db(enregistrement).select())>0:
        deleg=db(enregistrement).select(db.Delegues.ALL)[0]
        
        #récupération du vote
        arguments=get_vote_deleg(q,deleg.id)
        vote=["Rappel de votre vote:"]
        for r in arguments[0]:
            vote.append(r)

        delegation=(db.Questions_Delegues.D_id==deleg.id)&(db.Questions_Delegues.Q_id==q)
        #il existe déjà une délégation sur la question
        if len(db(delegation).select())>0:    #Alors on propose l'annulation/la modification
            message='Vous êtes déjà délégué pour la question N°%s ,vous pouvez modifier ou annuler'%q
            old_row=db(delegation).select()[0]
            argumentaire=old_row.argumentaire
            delegue=True
            checktext="Décochez pour annuler votre délégation"
            ischecked='on'
        else:                                         #Sinon on en crée une 
            message='Vous souhaitez être délégué pour la question N°%s'%q
            argumentaire=''
            delegue=False
            checktext="Cochez pour accepter la délégation"
            ischecked=''
            
            #après avoir vérifié que son vote ne provient pas d'une délégation...
            if is_vote_delegue(auth.user.id,q)!=0:
                d_id=is_vote_delegue(auth.user.id,q)
                deleg=db(db.Delegues.id==d_id).select(db.Delegues.ALL)[0]
                a=db(db.auth_user.id==deleg.U_id).select(db.auth_user.ALL)[0]
                nom=a.first_name+' '+a.last_name
                session.flash="Vous ne pouvez pas être délégué pour la question %s que vous avez vous même délégué à %s !" %(q,nom)
                redirect(URL(r=request,c='default',f='listes'))
            
        form=FORM(TABLE(TR(checktext, INPUT(_type='checkbox', _name='acceptation',value=ischecked)),
                        TR(TEXTAREA(_name='argumentaire', value=argumentaire)),
                        TR(INPUT(_type='submit',_value='Valider'))))
                  
        if form.accepts(request.vars,session):
            if form.vars.acceptation !='on':
                if delegue==False:
                    session.flash="Vous n'avez pas accepté d'être délégué pour la question %s " %q
                if delegue==True:                    
                    session.flash="Vous avez annulé votre délégation pour la question %s " %q
                    db(delegation).delete() 
                redirect(URL(r=request,c='default',f='listes'))
                
            argumentaire=form.vars.argumentaire      
            if delegue==False:          
                delegation_id=db.Questions_Delegues.insert(D_id=deleg.id,Q_id=q,argumentaire=argumentaire)
                session.flash="Vous êtes délégué pour la question %s  !" %q
                redirect(URL(r=request,c='default',f='listes'))
                
            if delegue==True:
                db(delegation).update(argumentaire=argumentaire)
                session.flash="Votre nouvelle argumentation pour la question %s a été mise à jour !" %q
                redirect(URL(r=request,c='default',f='listes'))
           
                
    #Si user n'est pas inscrit comme délégué (normalement impossible car n'a pas le bouton...)
    else:
        response.flash="vous devez être délégué..."
        message=message+str(q)            

    return dict(message=message,question=question,vote=vote,form=form)
    


def delegued(Q_id,D_id):
    rep="Non"
    if auth.is_logged_in():
        deleg=db((db.Questions_Delegues.D_id==D_id)&(db.Questions_Delegues.Q_id==Q_id)).select()
        if len(deleg)>0:
            rep = "Oui"
        else:
            rep = "Non"
    return rep
    
def is_vote_delegue(U_id,Q_id):
    #recherche si un vote est issu d'une délégation (retourne 0 ou D_id)
    ret=0
    vote=(db.Votes.U_id==U_id)&(db.Votes.Q_id==Q_id)
    #si vote existant
    if len(db(vote).select())>0:
        v = db(vote).select()[0]
        ret=int(v.D_id) 
    return ret

def get_vote_deleg(Q_id,D_id):
    #récupère le vote d'un délégé 
    deleg=db(db.Delegues.id==D_id).select()[0]
    U_id=deleg.U_id
    present=deleg.Presentation
    ret=None
    vote=(db.Votes.U_id==U_id)&(db.Votes.Q_id==Q_id)
    #si vote existant (et normalement pour arriver là ...il l'est!)
    if len(db(vote).select())>0:
        v = db(vote).select()[0]
        ret=(bulletin_texte(Q_id,v.Buletin) ,present,v.Buletin)
    return ret

def get_argumentaire(Q_id,D_id):
    #Recherche argumentation    
    delegation=(db.Questions_Delegues.D_id==D_id)&(db.Questions_Delegues.Q_id==Q_id)
    #il existe une délégation sur la question
    if len(db(delegation).select())>0:    
        old_row=db(delegation).select()[0]
        argumentaire=old_row.argumentaire
    return argumentaire        


@auth.requires_login()           
def deleg_vote():
    Q_id=request.args[0]
    items=[('0: aucun','aucun')]
    row=db(db.Questions.id==Q_id).select(db.Questions.ALL)[0]
    question=row.description
    les_delegues=db().select(db.Delegues.ALL)
    for d in les_delegues:
        U_id=d.U_id
        if delegued(Q_id,d.id)=="Oui":
            if U_id==auth.user.id:
                session.flash="Vous ne pouvez pas déléguer votre vote sur la question %s pour laquelle vous êtes délégué !" %Q_id
                redirect(URL(r=request,c='default',f='listes'))
            a=db(db.auth_user.id==U_id).select(db.auth_user.ALL)[0]
            nom=a.first_name+' '+a.last_name
            valeur=str(d.id)+': '+nom
            items.append((valeur,nom))
    options=[OPTION(v,_value=k) for (k,v) in items]
    keys=[k for (k,v) in items]
            
    form=FORM(TABLE(TR(SELECT(options,_id="deleg_choisi",_name="deleg_choisi",requires=IS_IN_SET(keys)),
                       INPUT(_type='button',
                             _value='Envoi',
                             _onclick="ajax('%s',['deleg_choisi'],'target')" % URL(r=request,f='voir_vote',args=[Q_id])))))                
                                 
    return dict(form=form,Q_id=Q_id,question=question,target=DIV(_id='target'))

def voir_vote():
    message=[]
    dico_reponses={}
    Q_id=request.args[0]
    if request.vars.deleg_choisi=='0: aucun':
        message=["=>pas de délégation"]
        session.d=0
    else:
        d_id=request.vars.deleg_choisi[:request.vars.deleg_choisi.find(':')]
        
        arguments=get_vote_deleg(Q_id,int(d_id))
        presentation=arguments[1]
        nom=request.vars.deleg_choisi[request.vars.deleg_choisi.find(':')+1:]
        message.append(H1(" Présentation de %s :" %nom))
        message.append(H2("%s" %presentation))
        message.append(" ")
        message.append(H1('%s Vous propose son vote :' %nom))
        for r in arguments[0]:
            message.append(r)
        message.append(H1("Qu'il argumente ainsi:"))
        argumentaire=get_argumentaire(Q_id,int(d_id))
        message.append(H2("%s"%argumentaire))
        session.v=arguments[2]
        session.q=Q_id
        session.d=int(d_id)
        message.append(A("Accepter ce vote", _href=URL(r=request,c='default',f='vote',args=[Q_id])))
    
    return TABLE(*[TR(v) for v in message]).xml()

def bulletin_texte(Q_id,bulletin):
    #renvoi une liste texte des réponses d'un bulletin
    dico_reponses={}
    selection=[]
    liste_bulletin=bulletin[1:].split('_')
    for r in db((db.Reponses.Q_id==Q_id)&(db.Reponses.visibilite=='True')).select(db.Reponses.ALL):
        dico_reponses[r.id]=r.titre
    for s in liste_bulletin:    
        selection.append(dico_reponses[int(s)])
    return selection
